// Copyright Protected | 2013
// Team-Cybertron, BUBT 

#include <Servo.h>
#include <LiquidCrystal.h>


//Pin defination
#define echoPin 7 // Echo Pin
#define trigPin 8 //Trigger Pin
#define left1 1
#define left2 2
#define right1 3
#define right2 4 

LiquidCrystal lcd(13,12,11,10,9,6);
//variables
long duration, distance;
long maximum = 20;
Servo servo;
char load[] = "<<<<<<<<>>>>>>>>";


//function signatures
long measure();
void goLeft();
void goRight();
void goBack();
void goForword();
void stopMotors();


void setup() 
{
 servo.attach(0);
 servo.write(95);
 lcd.begin(16, 2);
 lcd.setCursor(4,0);
 lcd.print("EXPLORER");
 lcd.setCursor(1,1);
 lcd.print("Team Cybertron");
 delay(1000);
 lcd.clear();
 pinMode(trigPin, OUTPUT);
 pinMode(echoPin, INPUT); 
 pinMode(left1, OUTPUT);
 pinMode(left2, OUTPUT);
 pinMode(right1, OUTPUT); 
 pinMode(right2, OUTPUT);
}


void loop() 
{

  long final;
  long result = measure();
  if((result <= maximum) && (result > 0))
   {
      stopMotors();
      lcd.setCursor(4,0);
      lcd.print("CHECKING");
      delay(500);
      lcd.clear();
      servo.write(45);
      lcd.setCursor(11,0);
      lcd.print("RIGHT");
      delay(1000);
      long result45 = measure();
      lcd.clear();
      servo.write(135);
      lcd.setCursor(0,0);
      lcd.print("LEFT");
      delay(1000);
      long result135 = measure();
      lcd.clear();
      servo.write(95);
      delay(1000);
      if(result45 != result135)
        {
           long final = max(result45, result135);
           if(final == result45){goLeft();}
           else{goRight(); return;}
       
        }
      else if((result45 == result135)&&((result45 > maximum) || (result135 > maximum))){goLeft();return;}
      else if((result45 == result135)&&((result45 < maximum) && (result135 < maximum))){goBack();return;}  
    }
  else
  { 
  goForword();
  return;
   }
}


long measure()
{
 digitalWrite(trigPin, LOW); 
 delayMicroseconds(2); 

 digitalWrite(trigPin, HIGH);
 delayMicroseconds(10); 
 
 digitalWrite(trigPin, LOW);
 duration = pulseIn(echoPin, HIGH);
 distance = duration/58.2;
 
 return distance;
}
void goLeft()
{
  digitalWrite(left2, LOW);
  digitalWrite(right2, HIGH);
  digitalWrite(left1, HIGH);
  digitalWrite(right1,LOW);
  lcdtext(2);
  delay(1000);

}
void goRight()
{
  digitalWrite(left2, HIGH);
  digitalWrite(right2, LOW);
  digitalWrite(left1, LOW);
  digitalWrite(right1,HIGH);
  lcdtext(1);
  delay(1000);
}
void goBack()
{
  digitalWrite(left2, HIGH);
  digitalWrite(right2, HIGH);
  digitalWrite(left1, LOW);
  digitalWrite(right1,LOW);
  delay(2000);
  digitalWrite(left2, HIGH);
  digitalWrite(right2, LOW);
  digitalWrite(left1, LOW);
  digitalWrite(right1,HIGH);
  delay(6000); 
  
}
void goForword()
{
  digitalWrite(left1, HIGH);
  digitalWrite(right1, HIGH);
  digitalWrite(left2, LOW);
  digitalWrite(right2,LOW);
  lcdtext(3);
}
void stopMotors()
{
  digitalWrite(left1, LOW);
  digitalWrite(right1, LOW);
  digitalWrite(left2, LOW);
  digitalWrite(right2,LOW);
}
void lcdtext(int a)
{ 

  
  switch (a) 
  {
  case 2:
    right();
    right();
    right();
    lcd.clear();
    break;
  case 1:
    left();
    left();
    left();
    lcd.clear();
    break;
   case 3:
    forword();
    lcd.clear();
    break;
  default: 
    break;
  }

}
void left(){
  for(int i=7; i>=0; i--)
    {
      lcd.setCursor(5,0);
      lcd.print("LEFT");
      lcd.setCursor(i,1);
      lcd.print(load[i]);
      delay(100);
    }
    lcd.clear();
}
void right(){
  for(int i=7; i>=0; i--)
    {
      lcd.setCursor(5,0);
      lcd.print("RIGHT");
      int a = abs(i-15);
      lcd.setCursor(a,1);
      lcd.print(load[a]);
      delay(100);
    }
    lcd.clear();
}
void forword()
{
  for(int i=7; i>=0; i--)
    {
      lcd.setCursor(5,0);
      lcd.print("FORWORD");
      int a = abs(i-15);
      lcd.setCursor(i,1);
      lcd.print(load[i]);
      lcd.setCursor(a,1);
      lcd.print(load[a]);
      delay(100);
    }
    lcd.clear();
}

